var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import ReactDOM from 'react-dom';

var mapStyles = {
    map: {
        position: 'absolute',
        width: '100%',
        height: '100%'
    }
};

export var CurrentLocation = function (_React$Component) {
    _inherits(CurrentLocation, _React$Component);

    function CurrentLocation(props) {
        _classCallCheck(this, CurrentLocation);

        var _this = _possibleConstructorReturn(this, (CurrentLocation.__proto__ || Object.getPrototypeOf(CurrentLocation)).call(this, props));

        var _this$props$initialCe = _this.props.initialCenter,
            lat = _this$props$initialCe.lat,
            lng = _this$props$initialCe.lng;


        _this.state = {
            currentLocation: {
                lat: lat,
                lng: lng
            }
        };
        return _this;
    }

    _createClass(CurrentLocation, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (prevProps.google !== this.props.google) {
                this.loadMap();
            }
            if (prevState.currentLocation !== this.state.currentLocation) {
                this.recenterMap();
            }
        }
    }, {
        key: 'recenterMap',
        value: function recenterMap() {
            var map = this.map;
            var current = this.state.currentLocation;
            var google = this.props.google;
            var maps = google.maps;

            if (map) {
                var center = new maps.LatLng(current.lat, current.lng);
                map.panTo(center);
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            if (this.props.centerAroundCurrentLocation) {
                if (navigator && navigator.geolocation) {
                    navigator.geolocation.getCurrentPosition(function (pos) {
                        var coords = pos.coords;
                        _this2.setState({
                            currentLocation: {
                                lat: coords.latitude,
                                lng: coords.longitude
                            }
                        });
                    });
                }
            }
            this.loadMap();
        }
    }, {
        key: 'loadMap',
        value: function loadMap() {
            if (this.props && this.props.google) {
                var google = this.props.google;

                var maps = google.maps;
                var mapRef = this.refs.map;

                //referencing the DOM element
                var node = ReactDOM.findDOMNode(mapRef);

                var zoom = this.props.zoom;
                var _state$currentLocatio = this.state.currentLocation,
                    lat = _state$currentLocatio.lat,
                    lng = _state$currentLocatio.lng;

                var center = new maps.LatLng(lat, lng);

                var MapConfig = Object.assign({}, {
                    center: center,
                    zoom: zoom
                });
                //maps.Map() is constructor for map instiance
                this.map = new maps.Map(node, MapConfig);
            }
        }
    }, {
        key: 'renderChildren',
        value: function renderChildren() {
            var _this3 = this;

            var children = this.props.children;


            if (!children) return;

            return React.Children.map(children, function (c) {
                if (!c) return;

                return React.cloneElement(c, {
                    map: _this3.map,
                    google: _this3.props.google,
                    mapCenter: _this3.state.currentLocation
                });
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var style = Object.assign({}, mapStyles.map);
            return React.createElement(
                'div',
                null,
                React.createElement(
                    'div',
                    { style: style, ref: 'map' },
                    'Loading map...'
                ),
                this.renderChildren()
            );
        }
    }]);

    return CurrentLocation;
}(React.Component);

CurrentLocation.defaultProps = {
    zoom: 14,
    initialCenter: {
        lat: -1.2884,
        lng: 36.8233
    },
    centerAroundCurrentLocation: false,
    visible: true
};

export default CurrentLocation;