import React, { Component } from 'react';
import { GoogleApiWrapper, Marker, InfoWindow } from 'google-maps-react';
/* Referenced: https://www.digitalocean.com/community/tutorials/how-to-integrate-the-google-maps-api-into-react-applications*/
import CurrentLocation from './Map'; //Complete View including MapMenu and Map
import MapOptions from "./Menu";
import './styles.css';

const googleApiKey = 'AIzaSyDwezB2D68_sOrVFtgY6n1qqUMDTOmBGDw';

export class MapContainer extends Component {
  // var markerLatLng = new this.props.google.maps.LatLng(0,0);  
  constructor(props){
    super(props);
    this.state = {
      showingInfoWindow: false, // Hide InfoWindow
      activeMarker: {},
      dynamicMarker: {},
      selectedPlace: {},
      selectedLng: -1,
      selectedLat: -1,
      pointLatLng: {},
      curLatLng: {},
      UserInput:{
        Distance: 50*1609,
        Increment: 10*1609,
        selectedMarker: 'currentLocation'
      },
      Markers: [],
      PlaceTypes: [],
      dynMarkerLocation:{
        lat: -1.0,
        lng: -1.0
      },
      dynMarkers: [
        {          
          name: "Current position",
          lat: -1.0,
          lng: -1.0
        }
      ]
    };  
  }

  calcPoint(google, Lat, Lng, Distance, Bearing)
  /* calcPoint: NOTES Not In Use - Hold For Potential Pin Creation
  *  Description: Calculates the new Point of Intrest given inputs google api, Lat & Lng of Current Point, Distance away from point, and Bearing of the new point relative from the current Point
  *  Inputs:
  *   google - google api
  *   Lat - Lat of Current/Known Point/Origin
  *   Lng - Lng of Current/Known Point/Origin
  *   Distance - Distance in (meters maybe?) from the Current/Known Point/Origin
  *   Bearing - Relative bearing from Current/Known Point/Origin
  */
  {
    
    var TempLatLng = new google.maps.LatLng(Lat, Lng);
    this.setState({
      pointLatLng: google.maps.geometry.spherical.computeOffset(TempLatLng, Distance, Bearing)
    })
    if(this.state.pointLatLng === null){
      console.log("AddPoint - API Return Null - Recall")
      this.AddPoint(google, Lat, Lng, Distance, Bearing);
    } 
    else{
      console.log("Computed Lat and Lng "+ JSON.stringify(this.state.pointLatLng));
    }
  }


  handleUserInputData = (Dist, Inc, types, keyword, selectedMarker) =>
    /* handleItemParent
  *  Description: Callback function for Child <MenuItem>
  *  Input:
  *   Child Calls Back with: 
  *     Distance 
  *     Bearing
  *     Icrement - Distance between Circles
  */
  { //Binds this to refer to the pertaining class
    console.log(`Dist: ${Dist} Inc: ${Inc} Marker: ${selectedMarker}`);
    console.log("handleUserInputData types: ", types, "selectedMarker: ", selectedMarker);
    this.setState({
      UserInput: {
        Distance: Dist,
        Increment: Inc,
        selectedMarker: selectedMarker,
      },
      PlaceTypes: types,
      PlaceKeyword: keyword,
      // dynMarkerLocation: {
      //   lat: '',
      //   lng: ''
      // }
    });
  }

  handleMarkerChanges = (markers) => 
  /* handleMarkerChanges
  *  Description: Callback function for Child <CurrentLocation>
  *  Input:
  *   Child Calls Back with: 
  *     Markers[]
  *         Marker List from Google API Call 
  */
  {
    this.setState({ Markers: markers});
  }
  onMarkerDragEnd = (coord, index) => {
    const { latLng } = coord;
    const lat = latLng.lat();
    const lng = latLng.lng();
    let tempPosit = {lat: lat, lng: lng};
    console.log('temp', tempPosit);
    this.setState(
      {
        dynMarkerLocation: {
        lat: lat,
        lng: lng
       }
      });
    // this.setState({
    //   dynMarkers: {position: tempPosit}
    // })
    // console.log(this.state.dynMarkers.position);
  };
  onMarkerClick = (props, marker, e) => {
    console.log("Marker ", marker);
    console.log("Props ", props);
    console.log("Props.place_id", props.place_id);
    console.log("marker.placeid ", marker.place_id);
    console.log("e", e);
     this.setState({
       selectedLat: props.position.lat,
       selectedLng: props.position.lng,
       selectedKey: props.place_id,
      selectedPlace: props,
      activeMarker: marker,
      showingInfoWindow: true
    });
  }
  onClose = props => {
    if (this.state.showingInfoWindow) {
      this.setState({
        showingInfoWindow: false,
        activeMarker: null
      });
    }
  };
  render() {
    const Markers = this.state.Markers;
    console.log("Markers ", Markers);
    const listMarkers = Markers.map((marker) =>
      <Marker
        key={marker.place_id}
        icon={marker.icon}
        title={marker.title}
        name={marker.title}
        position={marker.position}
        onClick={this.onMarkerClick}
      ></Marker>
    );
    return (
    <><div>
       <MapOptions handleUserInputData={this.handleUserInputData} dataFromParent = {this.state.UserInput} Markers={this.state.Markers}>
       </MapOptions> 
      <CurrentLocation id="map-layer" 
        handleMarkerChanges={this.handleMarkerChanges} 
        dataFromParent = {this.state.UserInput} 
          selectedMarker = {this.state.UserInput.selectedMarker}
          dynMarkerLocation = {this.state.dynMarkerLocation}
        PlaceTypes = {this.state.PlaceTypes}
        PlaceKeyword = {this.state.PlaceKeyword}
        centerAroundCurrentLocation google={this.props.google}>
         <Marker /*onClick={this.onMarkerClick}*/ title={"Your Current Location."} name={'Current Location'} id={0}
          icon={{
                path: "M17.402,0H5.643C2.526,0,0,3.467,0,6.584v34.804c0,3.116,2.526,5.644,5.643,5.644h11.759c3.116,0,5.644-2.527,5.644-5.644 V6.584C23.044,3.467,20.518,0,17.402,0z M22.057,14.188v11.665l-2.729,0.351v-4.806L22.057,14.188z M20.625,10.773 c-1.016,3.9-2.219,8.51-2.219,8.51H4.638l-2.222-8.51C2.417,10.773,11.3,7.755,20.625,10.773z M3.748,21.713v4.492l-2.73-0.349 V14.502L3.748,21.713z M1.018,37.938V27.579l2.73,0.343v8.196L1.018,37.938z M2.575,40.882l2.218-3.336h13.771l2.219,3.336H2.575z M19.328,35.805v-7.872l2.729-0.355v10.048L19.328,35.805z",
                scale: .7,
                strokeColor: 'white',
                strokeWeight: .10,
                fillOpacity: 1,
                fillColor: '#404040',
                offset: '5%',
                anchor: new this.props.google.maps.Point(10, 25) // orig 10,50 back of car, 10,0 front of car, 10,25 center of car
              }}>       
        </Marker>
        {this.state.dynMarkers.map((marker, index) =>
          <Marker 
            key={index}
            draggable={true}
            onDragend={(t, map, coord) => this.onMarkerDragEnd(coord, index)}
            name={marker.name}
          />
        )}
        {listMarkers}

        <InfoWindow
          marker={this.state.activeMarker}
          visible={this.state.showingInfoWindow}>
            <div>
              <h5>{this.state.activeMarker.title}</h5>
              <a href={"http://www.google.com/maps/place/"+this.state.selectedLat+","+this.state.selectedLng}>Open in Google Maps</a>
            </div>
        </InfoWindow>
        </CurrentLocation>        
    </div></>
    );
  }
}

export default GoogleApiWrapper({
  apiKey: googleApiKey,
  libraries: ['places', 'geometry']
})(MapContainer);