import { Component } from "react";
import React from 'react';
import $ from 'jquery';

class MenuItem extends Component {
    state = {
            isClicked: 'false',
            Keyword: '',
            selectedMarker: 'currentLocation',
            Dist: 10,
            Offset: 5
    }
    onClickSendData = (event) => {
        // let selected = document.querySelector('input[type=radio][name=poi]:checked'); /* For Radio Buttons - Get currently selected Button */
        let types = $("input:checkbox[name=poi]:checked").map(function() {
            return this.value;
        }).get();
        console.log("MenuItem.onClickSendData types:", types);
        console.log("MenuItem.onClickSendData selectedMarker", this.state.selectedMarker);
        this.props.handleUserInputData(this.state.Dist*1609.344, this.state.Increment*1609.344, types, 
            this.state.Keyword, this.state.selectedMarker);
    }
    handleDistChange = (event) => {
            this.setState({Dist: event.target.value});
    }
    handleBrgChange = (event) => {
        this.setState({Brg: event.target.value});
    }
    handleIncrementChange = (event) => {
        this.setState({Increment: event.target.value});
    }
    handleKeywordChange = (event) => {
        console.log('handleKeywordChange', event.target.value);
        this.setState({Keyword: event.target.value});
    }
    handleToggleClick = event => {
        console.log('handleToggleChange markerSelection Value', event.target.value);
        this.setState({selectedMarker: event.target.value});
        
        event.target.checked = 'checked';
    }
    handlecurLocClick = event => {
        console.log('handleToggleChange markerSelection Value', event.target.value);
        this.setState({selectedMarker: event.target.value});
        document.getElementById("markerLocation").checked = false;
        event.target.checked = 'checked';
    }
    handleMarkerLocClick = event => {
        console.log('handleToggleChange markerSelection Value', event.target.value);
        this.setState({selectedMarker: event.target.value});
        document.getElementById("currentLocation").checked = false;
        event.target.checked = true;
    }
    render(props){
        return(
            <><div className="card">
                <div className="card-body">
                <div className="navbar-nav">
                    <li className="nav-item"><a href="https://compsci04.snc.edu/cs460/2021/vanvlj/index.html">Home</a><br /></li>
                </div>
                    <h5 className="card-title">Map Inputs</h5>
                    <div>
                        <label><input type="radio" id="currentLocation" name="Location" value="currentLocation" onClick={this.handlecurLocClick}></input>&nbsp;Current Location</label>&nbsp;&nbsp;&nbsp;&nbsp;
                        <label><input type="radio" id="markerLocation" name="Location" value="markerLocation" onClick={this.handleMarkerLocClick}></input>&nbsp;Marker Location</label>
                    <br/>
                    <label>
                        Keyword Search:&nbsp;
                        <input type="text" value={this.state.Keyword} onChange={this.handleKeywordChange} placeholder='(optional)' />
                    </label><br/>
                    <label>
                        Distance to Middle Circle (Mi):&nbsp;
                        <input type="number" onChange={this.handleDistChange} placeholder='(required)'/>  {/*Make Required Values and Set Tolerance for Bearing*/}
                    </label><br/>
                    <label>
                        Distance Between Circles (Mi):&nbsp;
                        <input type="number" onChange={this.handleIncrementChange} placeholder='(required)'/>
                    </label>
                    <br/> 
                    <div> 
                        <p>Select A Place of Interest:</p>
                        <table className="table table-borderless">
                        <tbody>
                        <tr>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="amusement_park" value="amusement_park"></input>
                                <label className="form-check-label" htmlFor="amusement_park">Amusement Park</label><br/>
                            </td>
                            <td>                        
                                <input className="form-check-input" type="checkbox" name="poi" id="car_repair" value="car_repair"></input>
                                <label className="form-check-label" htmlFor="car_repair">Car Repair</label><br/>
                            </td>
                            <td>                        
                                <input className="form-check-input" type="checkbox" name="poi" id="hospital" value="hospital"></input>
                                <label className="form-check-label" htmlFor="hospital">Hospital</label><br/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="gas_station" value="gas_station"></input>
                                <label className="form-check-label" htmlFor="gas_station">Gas Station</label><br/>
                            </td>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="liquor_store" value="liquor_store"></input>
                                <label className="form-check-label" htmlFor="liquor_store">Liquor Store</label><br/>
                            </td>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="lodging" value="lodging"></input>
                                <label className="form-check-label" htmlFor="lodging">Lodging</label><br/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="museum" value="museum"></input>
                                <label className="form-check-label" htmlFor="museum">Museum</label><br/>
                            </td>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="park" value="park"></input>
                                <label className="form-check-label" htmlFor="park">Park</label><br/>
                            </td>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="restaurant" value="restaurant"></input>
                                <label className="form-check-label" htmlFor="restaurant">Restaurant</label><br/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="tourist_attraction" value="tourist_attraction"></input>
                                <label className="form-check-label" htmlFor="tourist_attraction">Tourist Traps</label><br/>
                            </td>
                            <td>
                                <input className="form-check-input" type="checkbox" name="poi" id="zoo" value="zoo"></input>
                                <label className="form-check-label" htmlFor="zoo">Zoo</label><br/>
                            </td>
                        </tr>
                        </tbody>
                        </table>
                    </div>
                        <button id="submitCoords" className="btn btn-primary" onClick={ this.onClickSendData } location="Current">Display Markers</button>
                    </div>
                </div>
            </div></>
        );
    }
}
export default MenuItem;